/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import junit.framework.TestCase;
import java.math.BigInteger;

public class TestPrimitives extends TestCase {

  //START:int
  public void testIntOverflow() {
    int TWO_BILLION = 2000000000;   //<label id="co.int.static"/>
    assertEquals(2, 1+1);           //<label id="co.int.math"/>
    //Zoinks -- Not four billion!
    assertEquals(-294967296 , TWO_BILLION + TWO_BILLION); //<label id="co.int.overflow"/>
  }
  //END:int

  //START:bigint
  public void testBigInteger() {
    BigInteger twobil = new BigInteger("2000000000"); //<label id="co.bigint.noliteral"/>
    BigInteger doubled = twobil.multiply(new BigInteger("2"));  //<label id="co.bigint.nomath"/>
    assertEquals(new BigInteger("4000000000"), doubled); //<label id="co.bigint.nooverflow"/>
  }
  //END:bigint

  public void testSomeLegalConversions() {
    assertEquals(2.1, 2 + 0.1);
    assertEquals("B12", "B" + 12);
  }

}
