/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package xml;

import junit.framework.TestCase;

import javax.xml.parsers.*;
import java.io.File;

import org.w3c.dom.*;

public class DOMDemo extends TestCase {
  public void testDOM() throws Exception {
    Target[] t = getTargets(new File(Setup.SIMPLE_BUILD_FILE));
    assertEquals(3, t.length);
    assertEquals("clean", t[0].getName());
    assertEquals("", t[0].getDepends());
  }

  //START:DOM
  public Target[] getTargets(File file) throws Exception {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document doc = db.parse(file);
    NodeList nl = doc.getElementsByTagName("target"); //<label id="code.dom.java.gbtn"/>
    Target[] targets = new Target[nl.getLength()];
    for (int n=0; n<nl.getLength(); n++) {    //<label id="code.dom.java.it"/>
      Target t = new Target();
      Element e = (Element) nl.item(0);
      t.setDepends(e.getAttribute("depends"));
      t.setName(e.getAttribute("name"));
      targets[n] = t;
    }
    return targets;
  }
  //END:DOM

}
