/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package xml;

import org.w3c.dom.*;

import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.dom.DOMSource;
import java.util.Properties;

public class DOMOutput {
  public static Document buildDOM()
      throws ParserConfigurationException {
    //START:build
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document doc = db.newDocument();
    Element root = doc.createElement("project");  //<label id="code.dom.create.create"/>
    root.setAttribute("name", "simple-ant");      //<label id="code.dom.create.attribute"/>
    doc.appendChild(root);                        //<label id="code.dom.create.append"/>
    Element target = doc.createElement("target");
    target.setAttribute("name", "compile");
    root.appendChild(target);
    return doc;
    //END:build
  }

  public static void printDOM(Document doc)
      throws TransformerException {
    //START:print
    TransformerFactory tf = TransformerFactory.newInstance();
    Transformer tform = tf.newTransformer();                    //<label id="code.dom.emit.new"/>
    tform.setOutputProperty(OutputKeys.INDENT, "yes");          //<label id="code.dom.emit.options"/>
    tform.transform(new DOMSource(doc), new StreamResult(System.out));
    //END:print
  }

  public static void main(String[] args) throws Exception {
    printDOM(buildDOM());
  }
}
