/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package xml;

import junit.framework.TestCase;

import javax.xml.stream.*;
import javax.xml.transform.Source;
import java.io.*;
import java.util.ArrayList;

public class StAXDemo extends TestCase {
  public void testGetTargets()
      throws FileNotFoundException, XMLStreamException {
    Target[] t = getTargets(new File(Setup.SIMPLE_BUILD_FILE));
    assertEquals(3, t.length);
    assertEquals("clean", t[0].getName());
    assertNull(t[0].getDepends());
  }

  //START:StAX
  public Target[] getTargets(File f)
      throws XMLStreamException, FileNotFoundException {
    XMLInputFactory xif= XMLInputFactory.newInstance();
    XMLStreamReader xsr = xif.createXMLStreamReader(new FileInputStream(f));
    final ArrayList al = new ArrayList();
    for (int event = xsr.next();      //<label id="code.stax.java.next"/>
         event != XMLStreamConstants.END_DOCUMENT;
         event=xsr.next()) {
      if (event == XMLStreamConstants.START_ELEMENT) { //<label id="code.stax.java.constants"/>
        if (xsr.getLocalName().equals("target")) {
          Target t = new Target();
          t.setDepends(xsr.getAttributeValue("", "depends"));
          t.setName(xsr.getAttributeValue("", "name"));
          al.add(t);
        }
      }
    }
    return (Target[]) al.toArray(new Target[al.size()]);
  }
  //END:StAX
}
