/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package xml;

import org.w3c.dom.*;

import javax.xml.xpath.*;
import javax.xml.parsers.*;
import java.io.File;

import junit.framework.TestCase;

public class XPathDemo extends TestCase {
  public void testXPath() throws Exception {
    String[] s = getTargetNamesDependingOnPrepare(new File(Setup.SIMPLE_BUILD_FILE));
    assertEquals(1, s.length);
    assertEquals("compile", s[0]);
  }

  //START:XPath
  public String[] getTargetNamesDependingOnPrepare(File file)
      throws Exception
  {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance(); //<label id="code.xpath.java.factory"/>
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document doc = db.parse(file);
    XPathFactory xpf = XPathFactory.newInstance();
    XPath xp = xpf.newXPath();

    NodeList nl = (NodeList) xp.evaluate("//target[@depends='prepare']/@name", //<label id="code.xpath.java.expr"/>
        doc, XPathConstants.NODESET);

    String[] results = new String[nl.getLength()];  //<label id="code.xpath.java.it"/>
    for (int n=0; n<nl.getLength(); n++) {
      results[n] = nl.item(n).getNodeValue();
    }
    return results;
  }
  //END:XPath
}
