#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
class PeopleController < ApplicationController
  
  before_filter :login_required, :except=>['index', 'list', 'show'] 
  
  
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @person_pages, @people = paginate :people, :per_page => 10
  end

  def show
    @person = Person.find(params[:id])
  end

  def new
    @person = Person.new
  end

  def create
    @person = Person.new(params[:person])
    if @person.save
      flash[:notice] = 'Person was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  
  def edit
    @person = Person.find(params[:id])
    logger.debug {"Found person #{@person.inspect}"}
  end
  

  def update
    
    @person = Person.find(params[:id])
    if @person.update_attributes(params[:person])
      # update succeeded...
    
      flash[:notice] = 'Person was successfully updated.'
      redirect_to :action => 'show', :id => @person
    else
      render :action => 'edit'
    end
  end

  
  def destroy
    logger.info "Entering destroy method"
    
    Person.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
