#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
# Be sure to restart your web server when you modify this file.

# Uncomment below to force Rails into production mode when 
# you don't control web/app server and can't set it the proper way
# ENV['RAILS_ENV'] ||= 'production'

# Specifies gem version of Rails to use when vendor/rails is not present
# RAILS_GEM_VERSION = '1.1.2'

# Bootstrap the Rails environment, frameworks, and default configuration
require File.join(File.dirname(__FILE__), 'boot')


class BetterLogger < Logger
  Format = "[%s#%d] %5s -- %s: %s\n"
  def format_message(severity, timestamp, msg, progname)
    Format % [timestamp, $$, severity, progname, msg]
  end
end



Rails::Initializer.run do |config|
  config.load_paths += %W( #{RAILS_ROOT}/vendor/rails/activeresource/lib )
  
  
  # Settings in config/environments/* take precedence those specified here
  
  # Skip frameworks you're not going to use
  # config.frameworks -= [ :action_web_service, :action_mailer ]

  # Add additional load paths for your own custom dirs
  # config.load_paths += %W( #{RAILS_ROOT}/extras )

  # Force all environments to use the same logger level 
  # (by default production uses :info, the others :debug)
  # config.log_level = :debug
  
  config.logger = BetterLogger.new "#{RAILS_ROOT}/log/#{RAILS_ENV}.log"
  config.logger.progname = 'rails_xt'  
  

  # Use the database for sessions instead of the file system
  # (create the session table with 'rake db:sessions:create')
  
  config.action_controller.session_store = :active_record_store
  

  # Use SQL instead of Active Record's schema dumper when creating the test database.
  # This is necessary if your schema can't be completely dumped by the schema dumper, 
  # like if you have constraints or database-specific column types
  # config.active_record.schema_format = :sql

  # Activate observers that should always be running
  # config.active_record.observers = :cacher, :garbage_collector

  # Make Active Record use UTC-base instead of local time
  # config.active_record.default_timezone = :utc
  
  # See Rails::Configuration for more options
end

# Add new inflection rules using the following format 
# (all these examples are active by default):
# Inflector.inflections do |inflect|
#   inflect.plural /^(ox)$/i, '\1en'
#   inflect.singular /^(ox)en/i, '\1'
#   inflect.irregular 'person', 'people'
#   inflect.uncountable %w( fish sheep )
# end

# Include your application configuration below

# including markaby manually to work around script/plugin bug
# http://code.whytheluckystiff.net/markaby/ticket/32
begin
  
  require 'markaby'
  require 'markaby/rails'
  ActionView::Base::register_template_handler('mab', 
    Markaby::ActionViewTemplateHandler)
  
rescue MissingSourceFile => e
  ActionController::Base.logger.info "Markaby not available"
end
ActiveRecord::Base.colorize_logging = false

