#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
require 'rexml/document'
include REXML


def get_targets(file)
  targets = []
  Document.new(file).elements.each("//target") do |e| 
    targets << {:name=>e.attributes["name"],
                :depends=>e.attributes["depends"]}
  end
  targets
end


require 'test/unit'
class TestDOM < Test::Unit::TestCase
  @@xmlfile = File.join(File.dirname(__FILE__), '../../../Rake/simple_ant/build.xml')

  def test_get_targets
    assert_equal([{:depends=>nil, :name=>"clean"},
                  {:depends=>nil, :name=>"prepare"},
                  {:depends=>"prepare", :name=>"compile"}],
                 get_targets(File.new(@@xmlfile)))
  end
end