#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class PersonTest < Test::Unit::TestCase
  fixtures :people
  INJECT_SQL = 'foo\' OR true OR id=\''
  
  def test_full_name
    p = Person.new :first_name => 'John', :last_name => 'Doe'  
    assert_equal 'John Doe', p.full_name
  end

  
  def test_find_by_first_name
    assert_equal people(:first), 
                 Person.find_by_first_name('Stuart')
  end
  
  
  def test_cascade_one_to_many
    p = Person.new :first_name=>self.name
    q = Quip.new :text=>self.name
    p.quips.push q
    p.save
    assert !p.new_record?
    assert !q.new_record?
  end

  def test_cascade_many_to_one
    p = Person.new :first_name=>self.name
    q = Quip.new :text=>self.name
    p.quips.push q
    q.save
    assert p.new_record?
    assert !q.new_record?
  end
  
  def test_find_by_any_name_UNSAFE
    assert_equal [people(:first)], Person.find_by_any_name_UNSAFE('Stuart')
    assert_equal [people(:first)], Person.find_by_any_name_UNSAFE('Halloway')
    # Bad!
    assert_equal 2, Person.find_by_any_name_UNSAFE(INJECT_SQL).size
  end

  def test_find_by_any_name
    assert_equal [people(:first)], Person.find_by_any_name('Stuart')
    assert_equal [people(:first)], Person.find_by_any_name('Halloway')
    # Good!
    assert_equal 0, Person.find_by_any_name(INJECT_SQL).size
  end

  def test_find_like_any_name_UNSAFE
    assert_equal [people(:first)], Person.find_like_any_name_UNSAFE('art')
    assert_equal [people(:first)], Person.find_like_any_name_UNSAFE('low')
    # Bad!
    assert_equal 2, Person.find_like_any_name_UNSAFE(INJECT_SQL).size
  end

  def test_find_like_any_name
    assert_equal [people(:first)], Person.find_like_any_name('art')
    assert_equal [people(:first)], Person.find_like_any_name('low')
    # Good!
    assert_equal 0, Person.find_like_any_name(INJECT_SQL).size
  end
  
  
end
